--friday lua funkin
local M = {}

local settingsPath = '/settings/sdtweakpreset.json'
local gradient_1_path = 'art/textures/sdsky/gradient_sunscale.png'
local gradient_2_path = 'art/textures/sdsky/gradient_sunscale2.png'
local gradient_night_path = 'art/textures/sdsky/gradient_sunscale_night.png'
local CCramp_path = ''

local colorCorrectionStrength = 1
local bloomthreshHold = 3
local SSAOcontrast = 8
local SSAOradius = 5
local SSAOsamples = 32
local RayLengthScattering = 0.007
local skyBrightness = 80
local shadowDistance = 3000
local shadowSoftness = 0.5
local brightness = 0.5
local exposure = 10
local colorizeAmount = 1

local FSKY = scenetree.sunsky -- O NO! an interloper reference?))

local function settingsSave()
    local s = {
        colorCorrectionStrength = colorCorrectionStrength, -- Color Corrention map strenght, i might add the CC map support later
        bloomthreshHold = bloomthreshHold,                 -- bloom threshold, pretty self-explanatory, lower values makes more bloom
        SSAOcontrast = SSAOcontrast,                       -- higher values make AO stronger
        SSAOradius = SSAOradius,                           -- radius of AO
        SSAOsamples = SSAOsamples,                         -- noisyness of AO, higher values are smoother
        RayLengthScattering = RayLengthScattering,         -- the curvature of light color diffusion relative to sun position, hard to explain in 1 sentence tho
        skyBrightness = skyBrightness,                     -- sky brightness, affect reflections too
        shadowDistance = shadowDistance,                   -- PSSM shadow draw distance, i wish they'd got rid of this outdated thing alltogether, even cascaded shadows would be fine
        shadowSoftness = shadowSoftness,                   -- PSSM shadow diffusion, or softness pretty much
        brightness = brightness,                           -- Sun brightness, yeah they just called it brightness, unlike the sky
        exposure = exposure,                               -- ambient? exposure, makes the scene slightly more color independed from sky color
        colorizeAmount = colorizeAmount,                   -- multiplier for the sky color, defined by the gradient map
        gradient_1_path = gradient_1_path,
        gradient_2_path = gradient_2_path,
        gradient_night_path = gradient_night_path,
        CCramp_path = CCramp_path,
    }
    jsonWriteFile(settingsPath, s, true)
end

local function settingsLoad()
    local s = jsonReadFile(settingsPath)
    if s then
        colorCorrectionStrength = s.colorCorrectionStrength or 1
        bloomthreshHold = s.bloomthreshHold or 3
        SSAOcontrast = s.SSAOcontrast or 8
        SSAOradius = s.SSAOradius or 5
        SSAOsamples = s.SSAOsamples or 32
        RayLengthScattering = s.RayLengthScattering or 0.007
        skyBrightness = s.skyBrightness or 80
        shadowDistance = s.shadowDistance or 3000
        shadowSoftness = s.shadowSoftness or 0.5
        brightness = s.brightness or 0.5
        exposure = s.exposure or 10
        colorizeAmount = s.colorizeAmount or 1
        gradient_1_path = s.gradient_1_path or 'art/textures/sdsky/gradient_sunscale.png'
        gradient_2_path = s.gradient_2_path or 'art/textures/sdsky/gradient_sunscale2.png'
        gradient_night_path = s.gradient_night_path or 'art/textures/sdsky/gradient_sunscale_night.png'
        CCramp_path = s.CCramp_path or ''
    end
end

local function SDSetGraphics()
    scenetree.PostEffectCombinePassObject.colorCorrectionStrength = (colorCorrectionStrength)
    scenetree.PostEffectBloomObject.threshHold = (bloomthreshHold)
    scenetree.SSAOPostFx:setContrast(SSAOcontrast)
    scenetree.SSAOPostFx:setRadius(SSAOradius)
    scenetree.SSAOPostFx:setSamples(SSAOsamples)
    scenetree.PostEffectCombinePassObject.colorCorrectionRampPath = CCramp_path

    if FSKY then                                      -- had to put a check here so it won't try to find sunsky in the main menu))
        FSKY.rayleighScattering = RayLengthScattering --i'll spell it properly for you
        FSKY.skyBrightness = skyBrightness
        FSKY.shadowDistance = shadowDistance
        FSKY.shadowSoftness = shadowSoftness
        FSKY.brightness = brightness
        FSKY.exposure = exposure
        FSKY.colorizeAmount = colorizeAmount

        FSKY.colorizeGradientFile = gradient_2_path
        FSKY.sunScaleGradientFile = gradient_1_path
        FSKY.ambientScaleGradientFile = gradient_1_path
        FSKY.fogScaleGradientFile = gradient_1_path
        FSKY.nightGradientFile = gradient_night_path
        FSKY.nightFogGradientFile = gradient_night_path
    end
end

local function ToggleEffect() --have to still add a button bc some things just can't update
    settingsLoad()
    SDSetGraphics()
    settingsSave()
    if FSKY then
        core_environment.setTimeOfDay(0.6) -- trying to manually update time of day so gradient maps would update the colors
    end
end

M.toggle = ToggleEffect
M.onClientMissionStart = ToggleEffect
M.OnExtensionLoaded = settingsLoad
M.onUpdate = SDSetGraphics
return M
